» IAM policy for IapAppEngineVersion

Three different resources help you manage your IAM policy for Iap AppEngineVersion. Each of these resources serves a different use case:

» google_iap_app_engine_version_iam_policy

data "google_iam_policy" "admin" {
    binding {
        role = "roles/iap.httpsResourceAccessor"
        members = [
            "user:jane@example.com",
        ]
    }
}

resource "google_iap_app_engine_version_iam_policy" "editor" {
    project = "${google_app_engine_standard_app_version.version.project}"
    app_id = "${google_app_engine_standard_app_version.version.project}"
    service = "${google_app_engine_standard_app_version.version.service}"
    version_id = "${google_app_engine_standard_app_version.version.version_id}"
    policy_data = "${data.google_iam_policy.admin.policy_data}"
}

With IAM Conditions (beta, Whitelist-only):

data "google_iam_policy" "admin" {
  binding {
    role = "roles/iap.httpsResourceAccessor"
    members = [
      "user:jane@example.com",
    ]

    condition {
      title       = "expires_after_2019_12_31"
      description = "Expiring at midnight of 2019-12-31"
      expression  = "request.time < timestamp(\"2020-01-01T00:00:00Z\")"
    }
  }
}

resource "google_iap_app_engine_version_iam_policy" "editor" {
    project = "${google_app_engine_standard_app_version.version.project}"
    app_id = "${google_app_engine_standard_app_version.version.project}"
    service = "${google_app_engine_standard_app_version.version.service}"
    version_id = "${google_app_engine_standard_app_version.version.version_id}"
  policy_data = "${data.google_iam_policy.admin.policy_data}"
}

» google_iap_app_engine_version_iam_binding

resource "google_iap_app_engine_version_iam_binding" "editor" {
    project = "${google_app_engine_standard_app_version.version.project}"
    app_id = "${google_app_engine_standard_app_version.version.project}"
    service = "${google_app_engine_standard_app_version.version.service}"
    version_id = "${google_app_engine_standard_app_version.version.version_id}"
    role = "roles/iap.httpsResourceAccessor"
    members = [
        "user:jane@example.com",
    ]
}

With IAM Conditions (beta, Whitelist-only):

resource "google_iap_app_engine_version_iam_binding" "editor" {
    project = "${google_app_engine_standard_app_version.version.project}"
    app_id = "${google_app_engine_standard_app_version.version.project}"
    service = "${google_app_engine_standard_app_version.version.service}"
    version_id = "${google_app_engine_standard_app_version.version.version_id}"
  role = "roles/iap.httpsResourceAccessor"
  members = [
    "user:jane@example.com",
  ]

  condition {
    title       = "expires_after_2019_12_31"
    description = "Expiring at midnight of 2019-12-31"
    expression  = "request.time < timestamp(\"2020-01-01T00:00:00Z\")"
  }
}

» google_iap_app_engine_version_iam_member

resource "google_iap_app_engine_version_iam_member" "editor" {
    project = "${google_app_engine_standard_app_version.version.project}"
    app_id = "${google_app_engine_standard_app_version.version.project}"
    service = "${google_app_engine_standard_app_version.version.service}"
    version_id = "${google_app_engine_standard_app_version.version.version_id}"
    role = "roles/iap.httpsResourceAccessor"
    member = "user:jane@example.com"
}

With IAM Conditions (beta, Whitelist-only):

resource "google_iap_app_engine_version_iam_member" "editor" {
    project = "${google_app_engine_standard_app_version.version.project}"
    app_id = "${google_app_engine_standard_app_version.version.project}"
    service = "${google_app_engine_standard_app_version.version.service}"
    version_id = "${google_app_engine_standard_app_version.version.version_id}"
  role = "roles/iap.httpsResourceAccessor"
  member = "user:jane@example.com"

  condition {
    title       = "expires_after_2019_12_31"
    description = "Expiring at midnight of 2019-12-31"
    expression  = "request.time < timestamp(\"2020-01-01T00:00:00Z\")"
  }
}

» Argument Reference

The following arguments are supported:

  • app_id - (Required) Id of the App Engine application. Used to find the parent resource to bind the IAM policy to
  • service - (Required) Service id of the App Engine application Used to find the parent resource to bind the IAM policy to
  • version_id - (Required) Version id of the App Engine application Used to find the parent resource to bind the IAM policy to

  • project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the project will be parsed from the identifier of the parent resource. If no project is provided in the parent identifier and no project is specified, the provider project is used.

  • member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:

    • allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.
    • allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.
    • user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.
    • serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.
    • group:{emailid}: An email address that represents a Google group. For example, admins@example.com.
    • domain:{domain}: A G Suite domain (primary, instead of alias) name that represents all the users of that domain. For example, google.com or example.com.
  • role - (Required) The role that should be applied. Only one google_iap_app_engine_version_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.

  • policy_data - (Required only by google_iap_app_engine_version_iam_policy) The policy data generated by a google_iam_policy data source.

  • condition - (Optional, Beta) An IAM Condition for a given binding. You must be whitelisted for the IAM Conditions private beta in order to use them in Terraform. Structure is documented below.


The condition block supports:

  • expression - (Required) Textual representation of an expression in Common Expression Language syntax.

  • title - (Required) A title for the expression, i.e. a short string describing its purpose.

  • description - (Optional) An optional description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.

» Attributes Reference

In addition to the arguments listed above, the following computed attributes are exported:

  • etag - (Computed) The etag of the IAM policy.

» Import

For all import syntaxes, the "resource in question" can take any of the following forms:

  • projects/{{project}}/iap_web/appengine-{{appId}}/services/{{service}}/versions/{{versionId}}
  • {{project}}/{{appId}}/{{service}}/{{versionId}}
  • {{appId}}/{{service}}/{{versionId}}
  • {{version}}

Any variables not passed in the import command will be taken from the provider configuration.

Iap appengineversion IAM resources can be imported using the resource identifiers, role, and member.

IAM member imports use space-delimited identifiers: the resource in question, the role, and the member identity, e.g. $ terraform import google_iap_app_engine_version_iam_member.editor "projects/{{project}}/iap_web/appengine-{{appId}}/services/{{service}}/versions/{{versionId}} roles/iap.httpsResourceAccessor jane@example.com"

IAM binding imports use space-delimited identifiers: the resource in question and the role, e.g. $ terraform import google_iap_app_engine_version_iam_binding.editor "projects/{{project}}/iap_web/appengine-{{appId}}/services/{{service}}/versions/{{versionId}} roles/iap.httpsResourceAccessor"

IAM policy imports use the identifier of the resource in question, e.g. $ terraform import google_iap_app_engine_version_iam_policy.editor projects/{{project}}/iap_web/appengine-{{appId}}/services/{{service}}/versions/{{versionId}}

» User Project Overrides

This resource supports User Project Overrides.